javascript:VALUES = {
    LOGIN_BUTTON_REG:new RegExp(window.mxautofill.getLoginButtonSignatureCodes(), "gi"),
    NONE_LOGIN_BUTTON_REG:new RegExp(window.mxautofill.getNonLoginButtonSignatureCodes(), "gi"),
    DOCUMENT_POSTION_NONE:1 << 0,
    DOCUMENT_POSTION_AFTER:1 << 1,
    DOCUMENT_POSTION_BEFORE:1 << 2,
    DOCUMENT_POSTION_INSIDE:1 << 3,
    DOCUMENT_POSTION_OUTSIDE:1 << 4,
    DOCUMENT_POSTION_EQUAL:1 << 5
};

var formInput = findUserNameAndPasswordInput();

function maybeUserName(c, d) {
    if (d != null && !d.hasChildNodes(c)) {
        return false;
    }
    if (!isTextBox(c) || isHidden(c)) {
        return false;
    }
    if (attrCheck(c, window.mxautofill.getUsernameSignatureCodes())) {
        return true;
    }
    if (contentCheck(c, window.mxautofill.getUsernameSignatureCodes())) {
        return true;
    }
    return false;
}

function maybeVerifyCode(b) {
    if (!(b.type == "text") || isHidden(b)) {
        return false;
    }
    if (attrCheck(b, [ "vcode", "verifycode" ])) {
        return true;
    }
    if (contentCheck(b, "验证码")) {
        return true;
    }
    return false;
}

function doCheckAndFillPhoneNumber() {
    var f = document.getElementsByTagName("input");
    for (var e = 0; e < f.length; ++e) {
        var d = f[e];
        if (!isHidden(d)) {
            if ((d.type == "tel" || d.type == "text" || d.type == "number") && contentCheck(d, "手机号|(phones*number)")) {
                return d;
            }
        }
    }
}

function isHidden(b) {
    if (b.nodeName == "BODY") {
        return false;
    }
    if (b.hidden || b.style.display == "none") {
        return true;
    }
    if (b.parentNode) {
        return isHidden(b.parentNode);
    }
    return false;
}

function attrCheck(d, f) {
    for (var e = 0; e < f.length; ++e) {
        if (d.id && d.id.toLowerCase().search(f[e]) >= 0 || d.name && d.name.toLowerCase().search(f[e]) >= 0) {
            return true;
        }
    }
    return false;
}

function contentCheck(c, d) {
    d = new RegExp(d, "gi");
    if (c.value && c.value.search(d) >= 0 || c.placeholder && c.placeholder.search(d) >= 0) {
        return true;
    }
    return false;
}

function strAttr(f, d) {
    var e = f[d];
    if (typeof e == "string") {
        return e;
    } else {
        e = f.getAttribute(d);
        if (typeof e == "string") {
            return e;
        } else {
            return "";
        }
    }
}

function catchForm(s) {
    var o = true;
    var y = s.getElementsByTagName("input");
    var x;
    var q;
    var v = -1;
    var u;
    var z = -1;
    var i;
    var p = -1;
    var r;
    for (var t = 0; t < y.length; ++t) {
        if (y[t].type == "password" && !isHidden(y[t])) {
            z = t;
            u = y[t];
            x = y[t].form;
            break;
        }
    }
    if (z <= 0) {
        if (o) {
            q = doCheckAndFillPhoneNumber();
        }
        return;
    } else {
        if (z == 1) {
            v = 0;
            q = y[0];
        } else {
            for (var t = z - 1; t >= 0; --t) {
                if (maybeUserName(y[t], x)) {
                    v = t;
                    q = y[t];
                    break;
                }
            }
        }
    }
    for (var t = z + 1; t < y.length; ++t) {
        if (maybeVerifyCode(y[t])) {
            p = t;
            i = y[t];
        }
    }
    if (q && u) {
        var w = {};
        w.usernameInput = q;
        w.passwordInput = u;
        return w;
    }
    return null;
}

function loginButtonCheck(b) {
    return b.search(VALUES.LOGIN_BUTTON_REG) >= 0 && b.search(VALUES.NONE_LOGIN_BUTTON_REG) < 0;
}

function isTextBox(b) {
    if (b && !b.disabled && /password|text|email|tel|number|search|textarea/i.test(b.type)) {
        return true;
    }
    return false;
}

function findUserNameAndPasswordInput() {
    var h = catchForm(window.document);
    if (h == null) {
        try {
            var g = window.document.getElementsByTagName("iframe");
            if (g.length > 0) {
                for (var f = 0; f < g.length; ++f) {
                    h = catchForm(g[f].contentWindow.document);
                }
            }
        } catch (e) {
            console.log(e.message);
        }
    }
    return h;
}

function hookLoginAction2(o, q, n) {
    if (!isTextBox(o) && o.hasAttribute && n.compareDocumentPosition(o) & VALUES.DOCUMENT_POSTION_BEFORE) {
        var p = strAttr(o, "id");
        var r = strAttr(o, "name");
        var j = strAttr(o, "value");
        var l = strAttr(o, "type");
        var m = strAttr(o, "class");
        var k = o.innerHTML ? o.innerHTML :"";
        if (loginButtonCheck(p) || loginButtonCheck(r) || loginButtonCheck(m) || loginButtonCheck(j) || k == "登录") {
            console.log("success id=" + p + ",name=" + r + ",value=" + j + ",className=" + m + ",type=" + l + ",innerHTML=" + k);
            q.push(o);
        }
    }
}

function mx_login_hook() {
    var r = formInput;
    if (r) {
        console.log("has username and password");
        var l = null;
        var i = null;
        var p = null;
        var s = [];
        var t = window.document.getElementsByTagName("form");
        var m = window.document.getElementsByTagName("button");
        var n = window.document.getElementsByTagName("input");
        var q = window.document.getElementsByTagName("a");
        if (t) {
            console.log("start to find login button in forms");
            for (var o = 0; o < t.length; ++o) {
                t[o].addEventListener("submit", function(e) {
                    console.log("form submited" + e.id);
                    var a = {};
                    a.documentURI = window.document.documentURI;
                    a.inputs = [];
                    var d = {};
                    d.id = "username";
                    d.name = "username";
                    d.value = r.usernameInput.value;
                    a.inputs.push(d);
                    var c = {};
                    c.id = "password";
                    c.name = "password";
                    c.value = r.passwordInput.value;
                    a.inputs.push(c);
                    var b = JSON.stringify(a);
                    window.mxautofill.catchform(b);
                }, false);
            }
        }
        if (m) {
            console.log("start to find login button in buttons");
            for (var o = 0; o < m.length; ++o) {
                hookLoginAction2(m[o], s, r.passwordInput);
            }
        }
        if (n) {
            console.log("start to find login button in inputs");
            for (var o = 0; o < n.length; ++o) {
                hookLoginAction2(n[o], s, r.passwordInput);
            }
        }
        if (q) {
            console.log("start to find login button in as");
            for (var o = 0; o < q.length; ++o) {
                hookLoginAction2(q[o], s, r.passwordInput);
            }
        }
        if (s.length > 0) {
            console.log("may be have found login button");
            console.log("length of s =" + s.length);
            for (var o = 0; o < s.length; ++o) {
                console.log("index=" + o + " id =" + s[o].id);
                s[o].addEventListener("click", function(e) {
                    console.log("loginBtn clicked" + e.id);
                    var a = {};
                    a.documentURI = window.document.documentURI;
                    a.inputs = [];
                    var d = {};
                    d.id = "username";
                    d.name = "username";
                    d.value = r.usernameInput.value;
                    a.inputs.push(d);
                    var c = {};
                    c.id = "password";
                    c.name = "password";
                    c.value = r.passwordInput.value;
                    a.inputs.push(c);
                    var b = JSON.stringify(a);
                    window.mxautofill.catchform(b);
                }, false);
            }
        }
    }
}

function mx_form_fill(f, e) {
    if (!window.mxautofill) {
    }
    var d = formInput;
    if (d) {
        d.usernameInput.value = f;
        d.passwordInput.value = e;
    }
}

function mx_auto_fill() {
    var b = window.mxautofill.enableAutoFill();
    mx_form_fill();
    if (b) {
        mx_login_hook();
    }
}

